local importPath=string.gsub(getfenv(1)._.Name,"%.Traits","").."."
local resourcePath=string.gsub(importPath,"%.","/").."Resources/"

-- to do:
-- need to revise when trait tree is implemented by Turbine


-- slottedTraits format: [characterName][index]={type,cat,id,subcat (optional, currently only valid for class traits), tier (optional, currently only valid for virtues/corruptions)}


--one tab per trait type
-- allow filling traits from scrollable list of traits -- probably need a separate pop-up window to list the available traits
-- would be nice to have the examine window for traits
-- the resource images would be nice but there's LOTS still undiscovered though :(
-- really need a data table of traits kind of like the recipe system, just not quite as large

-- Traits table format: allegiance, type (virtue/corruption, legendary, class, racial), name, resourceID, examine ID

import (importPath.."TraitData");

function loadData()
	-- load saved settings
	slottedTraits=PatchDataLoad( Turbine.DataScope.Server, "AltViewer_SlottedTraits");
	if slottedTraits==nil then
		slottedTraits=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_SlottedTraits");
	end
	if slottedTraits==nil then
		slottedTraits={};
	end
end
loadData()

TraitsPanel=Turbine.UI.Control()
TraitsPanel:SetMouseVisible(false);
TraitsPanel:SetSize(200,200);

TraitsPanel.LoadingSelections=false; -- flag used to disable the CheckedChanged event handler when loading character data
TraitsPanel.GetSubCat=function(category)
	local value=1;
	local tmpVal;
	-- returns the appropriate class/race subcategory
	if charList[selectedCharName].Alignment==1 then
		if category==1 then
			-- virtues are all subcat 1
			value=1;
		elseif category==2 then
			--race
			tmpVal=charList[selectedCharName].Race;
			if tmpVal==Turbine.Gameplay.Race.Dwarf then
				value=1;
			elseif tmpVal==Turbine.Gameplay.Race.Elf then
				value=2;
			elseif tmpVal==Turbine.Gameplay.Race.Hobbit then
				value=3;
			elseif tmpVal==Turbine.Gameplay.Race.Man then
				value=4;
			end
		else
			-- class
			tmpVal=charList[selectedCharName].Class;
			if tmpVal==Turbine.Gameplay.Class.Burglar then
				value=1;
			elseif tmpVal==Turbine.Gameplay.Class.Captain then
				value=2;
			elseif tmpVal==Turbine.Gameplay.Class.Champion then
				value=3;
			elseif tmpVal==Turbine.Gameplay.Class.Guardian then
				value=4;
			elseif tmpVal==Turbine.Gameplay.Class.Hunter then
				value=5;
			elseif tmpVal==Turbine.Gameplay.Class.LoreMaster then
				value=6;
			elseif tmpVal==Turbine.Gameplay.Class.Minstrel then
				value=7;
			elseif tmpVal==Turbine.Gameplay.Class.RuneKeeper then
				value=8;
			elseif tmpVal==Turbine.Gameplay.Class.Warden then
				value=9;
			end
		end
	else
		if category==1 then
			value=1;
		elseif category==2 then
			--race
			tmpVal=charList[selectedCharName].Race;
			-- note, the race enumeration Values are missing for creepside
			--Turbine.Gameplay.Race.Orc=7
			--Turbine.Gameplay.Race.Spider=12
			--Turbine.Gameplay.Race.Uruk=6
			--Turbine.Gameplay.Race.Warg=66
			if tmpVal==7 then
				value=1;
			elseif tmpVal==12 then
				value=2;
			elseif tmpVal==6 then
				value=3;
			elseif tmpVal==66 then
				value=4;
			end
		else
			-- class
			tmpVal=charList[selectedCharName].Class;
			if tmpVal==Turbine.Gameplay.Class.BlackArrow then
				value=1;
			elseif tmpVal==Turbine.Gameplay.Class.Defiler then
				value=2;
			elseif tmpVal==Turbine.Gameplay.Class.Reaver then
				value=3;
			elseif tmpVal==Turbine.Gameplay.Class.Stalker then
				value=4;
			elseif tmpVal==Turbine.Gameplay.Class.WarLeader then
				value=5;
			elseif tmpVal==Turbine.Gameplay.Class.Weaver then
				value=6;
			end
		end
	end
	return value;
end

-- create panel controls
TraitsPanel.Tab=TabControl();
TraitsPanel.Tab:SetParent(TraitsPanel);
TraitsPanel.Tab:SetFont(Turbine.UI.Lotro.Font.Verdana16);

tabColor={Turbine.UI.Color(0,0,.15),Turbine.UI.Color(.15,.1,0),Turbine.UI.Color(0,.15,0),Turbine.UI.Color(.15,0,0)}
TraitsPanel.Slots={{5,5,7,3},{6,5,7,1}};

TraitsPanel.Tab:SetSize(TraitsPanel:GetSize())
for tmpIndex=1,4 do
	TmpPanel=TraitsPanel.Tab:AddTab(Trait[charList[selectedCharName].Alignment][tmpIndex].Name[language],Turbine.UI.Color(tabColor[tmpIndex].R*5.26,tabColor[tmpIndex].G*5.26,tabColor[tmpIndex].B*5.26));

	TmpPanel.SelectBtn=Turbine.UI.Lotro.Button();
	TmpPanel.SelectBtn:SetParent(TmpPanel);
	TmpPanel.SelectBtn:SetSize(100,22);
	TmpPanel.SelectBtn:SetPosition(35,3);
	TmpPanel.SelectBtn:SetText(Resource[language][23]);
	TmpPanel.SelectBtn.Index=tmpIndex;
	TmpPanel.SelectBtn.MouseClick=function(sender,args)			
		TraitsPanel:ShowTraitSelection(sender.Index);
	end
	TmpPanel.Equipped=Turbine.UI.ListBox();
	TmpPanel.Equipped:SetParent(TmpPanel);
	TmpPanel.Equipped:SetPosition(1,26);
	TmpPanel.Equipped:SetSize(TmpPanel:GetWidth()-14,TmpPanel:GetHeight()-27);
	TmpPanel.VScroll=Turbine.UI.Lotro.ScrollBar();
	TmpPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	TmpPanel.VScroll:SetParent(TmpPanel);
	TmpPanel.VScroll:SetPosition(TmpPanel:GetWidth()-13,26);
	TmpPanel.VScroll:SetSize(12,TmpPanel.Equipped:GetHeight());
	TmpPanel.Equipped:SetVerticalScrollBar(TmpPanel.VScroll);

end

TraitsPanel.Tab.Tabs[1].Button:SetTop(0);
TraitsPanel.TraitSelection={};
for tmpIndex=1,4 do
	TraitsPanel.TraitSelection[tmpIndex]=Turbine.UI.Control();
	TraitsPanel.TraitSelection[tmpIndex]:SetParent(TraitsPanel);
	TraitsPanel.TraitSelection[tmpIndex]:SetVisible(false);
	TraitsPanel.TraitSelection[tmpIndex]:SetBackColor(tabColor[tmpIndex]);
	TraitsPanel.TraitSelection[tmpIndex]:SetZOrder(5);
	TraitsPanel.TraitSelection[tmpIndex]:SetSize(TraitsPanel:GetSize());
	TraitsPanel.TraitSelection[tmpIndex].OKBtn=Turbine.UI.Lotro.Button();
	TraitsPanel.TraitSelection[tmpIndex].OKBtn:SetParent(TraitsPanel.TraitSelection[tmpIndex]);
	TraitsPanel.TraitSelection[tmpIndex].OKBtn:SetSize(90,22);
	TraitsPanel.TraitSelection[tmpIndex].OKBtn:SetText(Resource[language][24]);
	TraitsPanel.TraitSelection[tmpIndex].OKBtn.Index=tmpIndex;
	TraitsPanel.TraitSelection[tmpIndex].OKBtn:SetPosition(1,1);
	TraitsPanel.TraitSelection[tmpIndex].OKBtn.MouseClick=function(sender,args)
		-- save the selected entries
		-- slottedTraits format: [characterName][index]={type,cat,id,subCat (optional), MaxTier}
		local type=sender.Index;
		local cat=TraitsPanel.GetSubCat(type);
		if slottedTraits[selectedCharName]==nil then slottedTraits[selectedCharName]={} end

		-- clear out any old traits matching this type since we define them from scratch
		local tmpIndex=1;
		while tmpIndex<=#slottedTraits[selectedCharName] do
			if slottedTraits[selectedCharName][tmpIndex]~=nil and slottedTraits[selectedCharName][tmpIndex][1]==type then
				table.remove(slottedTraits[selectedCharName],tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end

		-- now add back in any selected traits for this type
		local tmpIndex;
		for tmpIndex=1,TraitsPanel.TraitSelection[type].TraitList:GetItemCount() do
			if TraitsPanel.TraitSelection[type].TraitList:GetItem(tmpIndex).Checked~=nil then
				if TraitsPanel.TraitSelection[type].TraitList:GetItem(tmpIndex).Checked:IsChecked() then
					table.insert(slottedTraits[selectedCharName],{type,cat,TraitsPanel.TraitSelection[type].TraitList:GetItem(tmpIndex).TraitID,TraitsPanel.TraitSelection[type].TraitList:GetItem(tmpIndex).SubClass,TraitsPanel.TraitSelection[type].TraitList:GetItem(tmpIndex).CurrentTier});
				end
			end
		end
		TraitsPanel:LoadCharData();
		TraitsPanel.TraitSelection[sender.Index]:SetVisible(false);
	end

	TraitsPanel.TraitSelection[tmpIndex].Caption=Turbine.UI.Label();
	TraitsPanel.TraitSelection[tmpIndex].Caption:SetParent(TraitsPanel.TraitSelection[tmpIndex]);
	TraitsPanel.TraitSelection[tmpIndex].Caption:SetSize(TraitsPanel.TraitSelection[tmpIndex]:GetWidth()-184,22);
	TraitsPanel.TraitSelection[tmpIndex].Caption:SetPosition(82,1);
	TraitsPanel.TraitSelection[tmpIndex].Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	TraitsPanel.TraitSelection[tmpIndex].NumberSelected=0;
	TraitsPanel.TraitSelection[tmpIndex].Caption:SetText(Trait[charList[selectedCharName].Alignment][tmpIndex].Name[language].." "..Resource[language][23].." ("..tostring(TraitsPanel.TraitSelection[tmpIndex].NumberSelected).."/"..tostring(TraitsPanel.Slots[charList[selectedCharName].Alignment][tmpIndex])..")"); -- number selected/number slots
	TraitsPanel.TraitSelection[tmpIndex].CancelBtn=Turbine.UI.Lotro.Button();
	TraitsPanel.TraitSelection[tmpIndex].CancelBtn:SetParent(TraitsPanel.TraitSelection[tmpIndex]);
	TraitsPanel.TraitSelection[tmpIndex].CancelBtn:SetSize(90,22);
	TraitsPanel.TraitSelection[tmpIndex].CancelBtn:SetText(Resource[language][25]);
	TraitsPanel.TraitSelection[tmpIndex].CancelBtn:SetPosition(TraitsPanel.TraitSelection[tmpIndex]:GetWidth()-91,1);
	TraitsPanel.TraitSelection[tmpIndex].CancelBtn.Index=tmpIndex;
	TraitsPanel.TraitSelection[tmpIndex].CancelBtn.MouseClick=function(sender,args)
-- really need to reset the list to the current list of selected values
		TraitsPanel.TraitSelection[sender.Index]:SetVisible(false);
	end

	TraitsPanel.TraitSelection[tmpIndex].TraitList=Turbine.UI.ListBox();
	TraitsPanel.TraitSelection[tmpIndex].TraitList:SetParent(TraitsPanel.TraitSelection[tmpIndex]);
	TraitsPanel.TraitSelection[tmpIndex].TraitList:SetSize(TraitsPanel.TraitSelection[tmpIndex]:GetWidth()-14,TraitsPanel.TraitSelection[tmpIndex]:GetHeight()-25)
	TraitsPanel.TraitSelection[tmpIndex].TraitList:SetPosition(1,24);
	TraitsPanel.TraitSelection[tmpIndex].VScroll=Turbine.UI.Lotro.ScrollBar();
	TraitsPanel.TraitSelection[tmpIndex].VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	TraitsPanel.TraitSelection[tmpIndex].VScroll:SetParent(TraitsPanel.TraitSelection[tmpIndex]);
	TraitsPanel.TraitSelection[tmpIndex].VScroll:SetPosition(TraitsPanel.TraitSelection[tmpIndex]:GetWidth()-13,24);
	TraitsPanel.TraitSelection[tmpIndex].VScroll:SetSize(12,TraitsPanel.TraitSelection[tmpIndex]:GetHeight()-22);
	TraitsPanel.TraitSelection[tmpIndex].TraitList:SetVerticalScrollBar(TraitsPanel.TraitSelection[tmpIndex].VScroll);
end

TraitsPanel.ShowTraitSelection=function(sender,type)
	TraitsPanel.TraitSelection[type].TraitList:ClearItems();

	-- populate the list
	local subCat=TraitsPanel.GetSubCat(type);

	for traitIndex,traitData in ipairs(Trait[charList[selectedCharName].Alignment][type][subCat]) do
		if Trait[charList[selectedCharName].Alignment][type][subCat].SubClassed==nil then
			local tmpRow=Turbine.UI.Control()
			tmpRow:SetParent(TraitsPanel.TraitSelection[type].TraitList)
			tmpRow:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth(),33)
			tmpRow.TraitID=traitData[1];
			tmpRow.SubClass=nil;
			tmpRow.Checked=Turbine.UI.Lotro.CheckBox();
			tmpRow.Checked:SetParent(tmpRow);
			tmpRow.Checked:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth(),32);
			tmpRow.Checked:SetPosition(0,0);
			tmpRow.Checked.TabIndex=type;
			tmpRow.Checked:SetChecked(false); -- a tad redundant but doesn't hurt
			tmpRow.Checked.CheckedChanged=function(sender)
				if not TraitsPanel.LoadingSelections then
					if sender:IsChecked() then
						TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected=TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected+1;
						if TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected>TraitsPanel.Slots[charList[selectedCharName].Alignment][sender.TabIndex] then
							sender:SetChecked(false);
						else
							TraitsPanel.TraitSelection[sender.TabIndex].Caption:SetText(Trait[charList[selectedCharName].Alignment][sender.TabIndex].Name[language].." "..Resource[language][23].." ("..tostring(TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(TraitsPanel.Slots[charList[selectedCharName].Alignment][sender.TabIndex])..")"); -- number selected/number slots
						end
					else
						TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected=TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected-1;
						TraitsPanel.TraitSelection[sender.TabIndex].Caption:SetText(Trait[charList[selectedCharName].Alignment][sender.TabIndex].Name[language].." "..Resource[language][23].." ("..tostring(TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(TraitsPanel.Slots[charList[selectedCharName].Alignment][sender.TabIndex])..")"); -- number selected/number slots
					end
				end
			end
			tmpRow.Icon=Turbine.UI.Control();
			tmpRow.Icon:SetParent(tmpRow);
			tmpRow.Icon:SetSize(32,32);
			tmpRow.Icon:SetPosition(17,0);
			if traitData[3]~=nil and traitData[3]>0 then
				tmpRow.Icon:SetBackground(traitData[3]);
			else
				tmpRow.Icon:SetBackground(0x410d461e); -- blank trait background
			end
			tmpRow.Icon:SetMouseVisible(false);
			tmpRow.Caption=Turbine.UI.Label();
			tmpRow.Caption:SetParent(tmpRow);
			tmpRow.Caption:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth()-50,32);
			tmpRow.Caption:SetPosition(50,0);
			tmpRow.Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
			tmpRow.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
			tmpRow.Caption:SetText(traitData[2][language]);
			tmpRow.Caption:SetMouseVisible(false);
			TraitsPanel.TraitSelection[type].TraitList:AddItem(tmpRow);
		else
			local subClass;
			local tmpRow=Turbine.UI.Control()
			tmpRow:SetParent(TraitsPanel.TraitSelection[type].TraitList)
			tmpRow:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth(),33)
			tmpRow.Caption=Turbine.UI.Label();
			tmpRow.Caption:SetParent(tmpRow);
			tmpRow.Caption:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth(),32);
			tmpRow.Caption:SetPosition(0,0);
			tmpRow.Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			tmpRow.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana20);
			tmpRow.Caption:SetText(traitData.Name[language]);
			tmpRow.Caption:SetMouseVisible(false);
			TraitsPanel.TraitSelection[type].TraitList:AddItem(tmpRow);

			for subClassIndex,subClass in ipairs(traitData) do
				-- we are in the Freep Class Traits and need to iterate through the trait "lines"
				local tmpRow=Turbine.UI.Control()
				tmpRow:SetParent(TraitsPanel.TraitSelection[type].TraitList)
				tmpRow:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth(),33)
				tmpRow.TraitID=subClass[1];
				tmpRow.SubClass=traitIndex; -- yeah, a little confusing, since the index meaning changes :( I don't really like this design but it's what it is
				tmpRow.Checked=Turbine.UI.Lotro.CheckBox();
				tmpRow.Checked:SetParent(tmpRow);
				tmpRow.Checked:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth(),32);
				tmpRow.Checked:SetPosition(0,0);
				tmpRow.Checked.TabIndex=type;
				tmpRow.Checked:SetChecked(false); -- a tad redundant but doesn't hurt
				tmpRow.Checked.CheckedChanged=function(sender)
					if not TraitsPanel.LoadingSelections then
						if sender:IsChecked() then
							TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected=TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected+1;
							if TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected>TraitsPanel.Slots[charList[selectedCharName].Alignment][sender.TabIndex] then
								sender:SetChecked(false);
							else
								TraitsPanel.TraitSelection[sender.TabIndex].Caption:SetText(Trait[charList[selectedCharName].Alignment][sender.TabIndex].Name[language].." "..Resource[language][23].." ("..tostring(TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(TraitsPanel.Slots[charList[selectedCharName].Alignment][sender.TabIndex])..")"); -- number selected/number slots
							end
						else
							TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected=TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected-1;
							TraitsPanel.TraitSelection[sender.TabIndex].Caption:SetText(Trait[charList[selectedCharName].Alignment][sender.TabIndex].Name[language].." "..Resource[language][23].." ("..tostring(TraitsPanel.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(TraitsPanel.Slots[charList[selectedCharName].Alignment][sender.TabIndex])..")"); -- number selected/number slots
						end
					end
				end
				tmpRow.Icon=Turbine.UI.Control();
				tmpRow.Icon:SetParent(tmpRow);
				tmpRow.Icon:SetSize(32,32);
				tmpRow.Icon:SetPosition(17,0);
				if subClass[3]~=nil and subClass[3]>0 then
					tmpRow.Icon:SetBackground(subClass[3]);
				else
					tmpRow.Icon:SetBackground(0x410d461e);
				end
				tmpRow.Icon:SetMouseVisible(false);
				tmpRow.Caption=Turbine.UI.Label();
				tmpRow.Caption:SetParent(tmpRow);
				tmpRow.Caption:SetSize(TraitsPanel.TraitSelection[type].TraitList:GetWidth()-50,32);
				tmpRow.Caption:SetPosition(50,0);
				tmpRow.Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
				tmpRow.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
				tmpRow.Caption:SetText(subClass[2][language]);
				tmpRow.Caption:SetMouseVisible(false);
				TraitsPanel.TraitSelection[type].TraitList:AddItem(tmpRow);
			end
		end
	end

	-- set the state before setting the event handler so we don't fire it when setting state initially
	local tmpIndex;
	local numberSelected=0;
	-- clear all of the checkboxes and reset the number selected to 0;
	TraitsPanel.LoadingSelections=true; -- we use this flag to disable the CheckedChanged event in the selection lists
	for tmpIndex=1,TraitsPanel.TraitSelection[type].TraitList:GetItemCount() do
		local tmpRow=TraitsPanel.TraitSelection[type].TraitList:GetItem(tmpIndex);
		if tmpRow.Checked~=nil then
			tmpRow.CurrentTier=nil;
			local tmpTraitIndex;
			local checked=false;
			if slottedTraits[selectedCharName]~=nil then
				for k,v in ipairs(slottedTraits[selectedCharName]) do
					if v[3]==tmpRow.TraitID then
						checked=true;
						tmpRow.CurrentTier=v[5];
						numberSelected=numberSelected+1;
						break;
					end
				end
			end
			tmpRow.Checked:SetChecked(checked); -- this will fire the checkedchanged event but is harmless since the flag disables the counter update
		end
	end
	TraitsPanel.TraitSelection[type].NumberSelected=numberSelected;
	TraitsPanel.TraitSelection[type].Caption:SetText(Trait[charList[selectedCharName].Alignment][type].Name[language].." "..Resource[language][23].." ("..tostring(numberSelected).."/"..tostring(TraitsPanel.Slots[charList[selectedCharName].Alignment][type])..")"); -- number selected/number slots
	TraitsPanel.LoadingSelections=false; -- we use this flag to disable the CheckedChanged event in the selection lists
	TraitsPanel.TraitSelection[type]:SetVisible(true);
end

TraitsPanel:SetVisible(false);

TraitsPanel.LoadCharData=function()
	for tmpIndex=1,4 do
		TraitsPanel.TraitSelection[tmpIndex]:SetVisible(false); -- hide the trait selction window if it was open
		--remove all of the prior rows - we have to do this because there are a different # of rows for Freeps and Creeps
		TraitsPanel.Tab.Tabs[tmpIndex].Equipped:ClearItems();
		-- don't bother displaying traits for the "All" character since it would be meaningless
		TraitsPanel.Tab.Tabs[tmpIndex]:SetText(Trait[charList[selectedCharName].Alignment][tmpIndex].Name[language]);

		local tmpSlot;
		for tmpSlot=1,TraitsPanel.Slots[charList[selectedCharName].Alignment][tmpIndex] do
			local tmpRow=Turbine.UI.Control();
			tmpRow:SetParent(TraitsPanel.Tab.Tabs[tmpIndex].Equipped);
			tmpRow:SetSize(TraitsPanel.Tab.Tabs[tmpIndex].Equipped:GetWidth(),34);
			tmpRow:SetBackColor(tabColor[tmpIndex]);
			tmpRow.Icon=Turbine.UI.Control();
			tmpRow.Icon:SetParent(tmpRow);
			tmpRow.Icon:SetSize(32,32);
			tmpRow.Icon:SetPosition(1,1);
			tmpRow.Icon:SetMouseVisible(false);
			tmpRow.Tier=Turbine.UI.Label();
			tmpRow.Tier:SetParent(tmpRow.Icon);
			tmpRow.Tier:SetSize(16,14);
			tmpRow.Tier:SetPosition(13,17);
			tmpRow.Tier:SetFont(Turbine.UI.Lotro.Font.Verdana14);
			tmpRow.Tier:SetForeColor(Turbine.UI.Color(1,1,1));
			tmpRow.Tier:SetOutlineColor(Turbine.UI.Color(0,0,0));
			tmpRow.Tier:SetFontStyle(Turbine.UI.FontStyle.Outline);
			tmpRow.Tier:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
			tmpRow.Tier:SetText("1");
			tmpRow.Tier:SetMouseVisible(false);
			tmpRow.Tier:SetVisible(false);
			tmpRow.Up=Turbine.UI.Control();
			tmpRow.Up:SetParent(tmpRow);
			tmpRow.Up:SetSize(10,10);
			tmpRow.Up:SetPosition(34,1);
			tmpRow.Up:SetVisible(false);
			tmpRow.Up:SetBackground(0x4100028c);
			tmpRow.Up.MouseEnter=function()
				tmpRow.Up:SetBackground(0x4100028d);
			end
			tmpRow.Up.MouseLeave=function()
				tmpRow.Up:SetBackground(0x4100028c);
			end
			tmpRow.Up.MouseClick=function(sender,args)
				local Row=sender:GetParent();
				local MaxTier=Row.MaxTier;
				local Tier=tonumber(Row.Tier:GetText())+1;
				if MaxTier==nil or Tier<=MaxTier then
					slottedTraits[selectedCharName][Row.TraitIndex][5]=Tier;
					Row.Tier:SetText(Tier);
				end
			end

			tmpRow.Down=Turbine.UI.Control();
			tmpRow.Down:SetParent(tmpRow);
			tmpRow.Down:SetSize(10,10);
			tmpRow.Down:SetPosition(34,22);
			tmpRow.Down:SetVisible(false);
			tmpRow.Down:SetBackground(0x4100028e);
			tmpRow.Down.MouseEnter=function()
				tmpRow.Down:SetBackground(0x4100028f);
			end
			tmpRow.Down.MouseLeave=function()
				tmpRow.Down:SetBackground(0x4100028e);
			end
			tmpRow.Down.MouseClick=function(sender,args)
				local row=sender:GetParent();
				local tier=tonumber(row.Tier:GetText())-1;
				if tier>0 then
					slottedTraits[selectedCharName][row.TraitIndex][5]=tier;
					row.Tier:SetText(tier);
				end
			end

			tmpRow.Name=Turbine.UI.Label();
			tmpRow.Name:SetParent(tmpRow);
			tmpRow.Name:SetSize(TraitsPanel.Tab.Tabs[tmpIndex].Equipped:GetWidth()-34,32);
			tmpRow.Name:SetPosition(34,1);
			tmpRow.Name:SetBackColor(Turbine.UI.Color(0,0,0));
			tmpRow.Name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
			TraitsPanel.Tab.Tabs[tmpIndex].Equipped:AddItem(tmpRow);
		end
	end

	local blankIndex={1,1,1,1};
	if slottedTraits[selectedCharName]~=nil then
		for traitIndex,slottedTrait in ipairs(slottedTraits[selectedCharName]) do
			local type, cat, id, subCat, tier=slottedTrait[1],slottedTrait[2],slottedTrait[3],slottedTrait[4],slottedTrait[5];
			local name,icon,examID,maxTier;
			-- each entry will have a type, Category, ID and SubCategory -- we look up the Name, Icon, and ExamID in case the Trait.lua file was updated
			if subCat==nil then
				for k,v in ipairs(Trait[charList[selectedCharName].Alignment][type][cat]) do
					if v[1]==id then
						name=v[2][language];
						icon=v[3];
						examID=v[4];
						maxTier=v[5];
						break
					end
				end
			else
				for k,v in ipairs(Trait[charList[selectedCharName].Alignment][type][cat][subCat]) do
					if v[1]==id then
						name=v[2][language];
						icon=v[3];
						examID=v[4];
						maxTier=v[5];
						break
					end
				end
			end
			if name~=nil then
				-- we found a matching Trait
				-- now fill in the first blank list entry on the type tab
				local tmpItem=TraitsPanel.Tab.Tabs[type].Equipped:GetItem(blankIndex[type]);
				blankIndex[type]=blankIndex[type]+1;
				if icon~=nil and icon>0 then
					tmpItem.Icon:SetBackground(icon);
				else
					tmpItem.Icon:SetBackground(0x410d461e);
				end
				tmpItem.Name:SetText(name);
				tmpItem.MaxTier=maxTier;
				tmpItem.TraitIndex=traitIndex;
				if maxTier~=nil then
					if tier==nil then
						tier=1;
						slottedTrait[5]=1;
					end
					tmpItem.Icon:SetMouseVisible(true);
					tmpItem.Up:SetVisible(true);
					tmpItem.Down:SetVisible(true);
					tmpItem.Name:SetLeft(44);
					tmpItem.Name:SetWidth(tmpItem:GetWidth()-44);
					tmpItem.Tier:SetVisible(true);
					tmpItem.Tier:SetText(tier);
				else
					tmpItem.Icon:SetMouseVisible(false);
					tmpItem.Tier:SetVisible(false);
					tmpItem.Up:SetVisible(false);
					tmpItem.Down:SetVisible(false);
					tmpItem.Name:SetLeft(34);
					tmpItem.Name:SetWidth(tmpItem:GetWidth()-34);
				end
			end
		end
	end
end

TraitsPanel.SaveData=function()
	PatchDataSave( Turbine.DataScope.Server, "AltViewer_slottedTraits",slottedTraits);
end

TraitsPanel.RemoveCallbacks=function()
end

TraitsPanel.RemoveCharacter=function(characterName)
	slottedTraits[characterName]=nil;
end

TraitsPanel.SizeChanged=function(sender,args)
	local newWidth,newHeight=mainWindow.PanelBack:GetSize();
	Turbine.UI.Control.SetSize(TraitsPanel,newWidth,newHeight);
	TraitsPanel.Tab:SetSize(newWidth,newHeight);
	for k,v in ipairs(TraitsPanel.Tab.Tabs) do
		v.SelectBtn:SetLeft((newWidth-4-v.SelectBtn:GetWidth())/2)
		v.Equipped:SetSize(newWidth-14,newHeight-47);
		for tmpSlot=1,v.Equipped:GetItemCount() do
			v.Equipped:GetItem(tmpSlot):SetWidth(newWidth-14);
			if v.Equipped:GetItem(tmpSlot).Up:IsVisible() then
				v.Equipped:GetItem(tmpSlot).Name:SetWidth(newWidth-58);
			else
				v.Equipped:GetItem(tmpSlot).Name:SetWidth(newWidth-48);
			end
		end
		v.VScroll:SetLeft(newWidth-13);
		v.VScroll:SetHeight(newHeight-47);
		TraitsPanel.TraitSelection[k]:SetSize(newWidth,newHeight);
		TraitsPanel.TraitSelection[k].TraitList:SetSize(newWidth-14,newHeight-25);
		for tmpSlot=1,TraitsPanel.TraitSelection[k].TraitList:GetItemCount() do
			local tmpItem=TraitsPanel.TraitSelection[k].TraitList:GetItem(tmpSlot);
			tmpItem:SetWidth(newWidth-14);
			if tmpItem.Checked~=nil then
				tmpItem.Checked:SetWidth(newWidth-14);
				tmpItem.Caption:SetWidth(newWidth-64);
			else
				tmpItem.Caption:SetWidth(newWidth-14);
			end
		end
		TraitsPanel.TraitSelection[k].VScroll:SetLeft(newWidth-13);
		TraitsPanel.TraitSelection[k].VScroll:SetHeight(newHeight-25);
		TraitsPanel.TraitSelection[k].CancelBtn:SetLeft(newWidth-91);
		TraitsPanel.TraitSelection[k].Caption:SetWidth(newWidth-184);
	end
end

TraitsPanel.SetLanguage=function()
	local tmpIndex;
	for tmpIndex=1,4 do
		TraitsPanel.Tab.Tabs[tmpIndex].SelectBtn:SetText(Resource[language][23]);
		TraitsPanel.TraitSelection[tmpIndex].OKBtn:SetText(Resource[language][24]);
		TraitsPanel.TraitSelection[tmpIndex].CancelBtn:SetText(Resource[language][25]);
		TraitsPanel.Tab.Tabs[tmpIndex]:SetText(Trait[charList[selectedCharName].Alignment][tmpIndex].Name[language])
		if charList[selectedCharName].Alignment~=nil then
			TraitsPanel.TraitSelection[tmpIndex].Caption:SetText(Trait[charList[selectedCharName].Alignment][tmpIndex].Name[language].." "..Resource[language][23]);
		end
		TraitsPanel.LoadCharData()
	end
end
TraitsPanel.SetColors=function()
	TraitsPanel:SetBackColor(settings.BackColor);
end
